package com.sun.xml.internal.ws.spi.db;

import java.security.PrivilegedActionException;
import java.security.AccessController;
import java.security.PrivilegedExceptionAction;
import java.lang.reflect.Method;

public class MethodSetter extends PropertySetterBase
{
    private Method method;
    
    public MethodSetter(Method m) {
        this.method = m;
        this.type = m.getParameterTypes()[0];
    }
    
    public Method getMethod() {
        return this.method;
    }
    
    @Override
    public <A> A getAnnotation(Class<A> annotationType) {
        Class<A> c = annotationType;
        return this.method.getAnnotation(c);
    }
    
    @Override
    public void set(final Object instance, Object resource) {
        final Object[] args = { resource };
        if (this.method.isAccessible()) {
            try {
                this.method.invoke(instance, args);
            }
            catch (Exception e2) {
                e2.printStackTrace();
            }
        }
        else {
            try {
                AccessController.doPrivileged(new PrivilegedExceptionAction<Object>() {
                    @Override
                    public Object run() throws IllegalAccessException {
                        if (!MethodSetter.this.method.isAccessible()) {
                            MethodSetter.this.method.setAccessible(true);
                        }
                        try {
                            MethodSetter.this.method.invoke(instance, args);
                        }
                        catch (Exception e) {
                            e.printStackTrace();
                        }
                        return null;
                    }
                });
            }
            catch (PrivilegedActionException e) {
                e.printStackTrace();
            }
        }
    }
}
